﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CompareInterfaceDemo
{
    public partial class FaceCompare : System.Web.UI.Page
    {
        private Regex regfaceid = new Regex("face_id\"[\\s\\S]*?\"(?<faceid>[\\s\\S]*?)\",[\\s\\S]*?position");

        protected void Page_Load(object sender, EventArgs e)
        {
            if (IsPostBack)
            {
            }
        }

        /// <summary>
        /// Convert image file to base64 string
        /// </summary>
        /// <param name="imgfile"></param>
        /// <returns></returns>
        private string Convertbase64(FileUpload imgfile)
        {
            if (imgfile.HasFile)
            {
                string savePath = Server.MapPath("~/upload/");
                if (!System.IO.Directory.Exists(savePath))
                {
                    System.IO.Directory.CreateDirectory(savePath);
                }

                savePath = savePath + "\\" + imgfile.FileName;
                imgfile.SaveAs(savePath);
                System.Drawing.Image img = System.Drawing.Image.FromFile(savePath);
                MemoryStream ms = new MemoryStream();
                img.Save(ms, System.Drawing.Imaging.ImageFormat.Jpeg);
                byte[] arr = new byte[ms.Length];
                ms.Position = 0;
                ms.Read(arr, 0, (int)ms.Length);
                ms.Close();
                return Convert.ToBase64String(arr);
            }
            else
            {
                return string.Empty;
            }
        }

        private string CheckingResult(FileUpload imgfile)
        {
            string result = string.Empty;
            if (imgfile.HasFile)
            {
                string strbase64 = this.Convertbase64(imgfile);
                if (!string.IsNullOrEmpty(strbase64))
                {
                    string appid = ConfigurationManager.AppSettings["appid"];
                    string appkey = ConfigurationManager.AppSettings["appkey"];
                    string postString = "app_id=" + appid + "&app_key=" + appkey + "&img=" + HttpUtility.UrlEncode(strbase64);
                    string url = "http://api.eyekey.com/face/Check/checking";

                    byte[] data = Encoding.ASCII.GetBytes(postString);
                    HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
                    req.Method = "POST";
                    req.ContentType = "application/x-www-form-urlencoded";
                    req.ContentLength = data.Length;

                    using (Stream reqStream = req.GetRequestStream())
                    {
                        //提交数据
                        reqStream.Write(data, 0, data.Length);
                    }

                    HttpWebResponse res = (HttpWebResponse)req.GetResponse();
                    StreamReader reader = new StreamReader(res.GetResponseStream(), Encoding.Default);
                    result = reader.ReadToEnd();

                    reader.Close();
                }
            }

            return result;
        }

        protected void btnCompare_Click(object sender, EventArgs e)
        {
            string checkingresult = this.CheckingResult(this.fup1);
            Match m1 = regfaceid.Match(checkingresult);
            string faceid1 = m1.Groups["faceid"].Value.ToString();

            string checkingresult2 = this.CheckingResult(this.fup2);
            Match m2 = regfaceid.Match(checkingresult2);
            string faceid2 = m2.Groups["faceid"].Value.ToString();

            if (!string.IsNullOrEmpty(faceid1) && !string.IsNullOrEmpty(faceid2))
            {
                string appid = ConfigurationManager.AppSettings["appid"];
                string appkey = ConfigurationManager.AppSettings["appkey"];
                string postString = "app_id=" + appid + "&app_key=" + appkey + "&face_id1=" + faceid1 + "&face_id2=" + faceid2;
                string url = "http://api.eyekey.com/face/Match/match_compare?" + postString;


                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
                req.Method = "GET";
                req.ContentType = "application/json";


                HttpWebResponse res = (HttpWebResponse)req.GetResponse();
                StreamReader reader = new StreamReader(res.GetResponseStream());
                this.lblCompareResult.Text = reader.ReadToEnd();

                reader.Close();




                //return responseContent.Split(new char[] { ',', ':' })[1];
            }
        }
    }
}